;peekobj.asm, makes peekobj.obj for use by high level languages

; A one-line makefile for this:
; \masm32\bin\ml /c /coff peekobj.asm

.386
.model flat, stdcall
option casemap:none
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib

public regs,mem,unloadpeek

.data
    regs dd load_and_do_regs
    mem dd load_and_do_mem
    caller dd ?
    peek_lib_handle dd ?
    peek_info dd ?

.code
peekdll$ db "peek.dll",0

load_and_do_mem:
    pop caller
    pushad
    pushfd
    call loadpeek
    popfd
    popad
    call mem
    jmp caller

load_and_do_regs:
    pushad
    pushfd
    call loadpeek
    popfd
    popad
    jmp regs

unloadpeek:
    pushfd
    pushad
    xor eax,eax
    xchg eax,peek_lib_handle
    test eax,eax
    jz short @F
    push eax
    call FreeLibrary
@@: popad
    popfd
    ret

loadpeek:
    pushfd
    mov eax,peek_lib_handle
    or eax,eax
    jnz short loadpeek_done_1
    cld
    push offset peekdll$
    call LoadLibrary
    or eax,eax
    jz short loadpeek_done
    mov peek_lib_handle,eax
    call @F
    db "info",0
@@: push eax
    call GetProcAddress
    push [eax+8]
    pop regs
    push [eax+0Ch]
    pop mem
loadpeek_done_1:
    mov eax,esp
loadpeek_done:
    popfd
    ret
end
